Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GuideDogRobotSpecialist Class Reference

`#include <GuideDogRobotSpecialist.h>`

Collaboration diagram for GuideDogRobotSpecialist:

[legend]
List of all members.

## Public Member Functions
| GuideDogRobotSpecialist (const Image &image, const CameraMatrix &cameraMatrix, const CameraMatrix &prevCameraMatrix, const ColorTable &colorTable, const ColorCorrector &colorCorrector, PlayersPercept &playersPercept)
| ~GuideDogRobotSpecialist ()
void | execute ()
## Private Member Functions
void | calculateScanLinesParallelToHorizon ()
void | scanParallelToHorizon ()
bool | isRed (int x, int y)
## Private Attributes
const Image & | image
| A reference to the image that is scanned for a goal.
const CameraMatrix & | cameraMatrix
| A reference to the camera matrix that describes position and rotation of the camera when the image was aquired.
const CameraMatrix & | prevCameraMatrix
| A reference to the previous camera matrix that describes position and rotation of the camera when the image was aquired.
const ColorTable & | colorTable
| A reference to the color table.
PlayersPercept & | playersPercept
| A reference to the singeplayer percept.
const ColorCorrector & | colorCorrector
| A reference to the color corrector.
Geometry::Line | horizonLine
| A representation of the horizon.
Geometry::Line | verticalLine
| A representation of the horizon.
int | numberOfHorizontalScanLines
| The number of horizontal scan lines.
Vector2< int > | leftPoint [maxNumberOfHorizontalScanLines]
| representation of the left points of the horizontal scan lines
Vector2< int > | rightPoint [maxNumberOfHorizontalScanLines]
| representation of the right points of the horizontal scan lines
## Static Private Attributes
const int | maxNumberOfHorizontalScanLines = 32

## Constructor & Destructor Documentation

GuideDogRobotSpecialist::GuideDogRobotSpecialist | ( | const Image & | image,
|  | const CameraMatrix & | cameraMatrix,
|  | const CameraMatrix & | prevCameraMatrix,
|  | const ColorTable & | colorTable,
|  | const ColorCorrector & | colorCorrector,
|  | PlayersPercept & | playersPercept
| ) |

| Definition at line 22 of file GuideDogRobotSpecialist.cpp.

GuideDogRobotSpecialist::~GuideDogRobotSpecialist | ( |  | ) |

| Definition at line 40 of file GuideDogRobotSpecialist.cpp.

## Member Function Documentation

void GuideDogRobotSpecialist::execute | ( |  | ) |

| Definition at line 44 of file GuideDogRobotSpecialist.cpp. References Geometry::Line::base, Geometry::calculateHorizon(), calculateScanLinesParallelToHorizon(), Image::cameraInfo, Geometry::Line::direction, horizonLine, INIT_DEBUG_IMAGE, scanParallelToHorizon(), SEND_DEBUG_IMAGE, verticalLine, Vector2< double >::x, and Vector2< double >::y.

Here is the call graph for this function:

void GuideDogRobotSpecialist::calculateScanLinesParallelToHorizon | ( |  | ) | `[private]`

| Definition at line 62 of file GuideDogRobotSpecialist.cpp. References Geometry::Line::base, Image::cameraInfo, Geometry::Line::direction, Geometry::getIntersectionPointsOfLineAndRectangle(), horizonLine, leftPoint, maxNumberOfHorizontalScanLines, numberOfHorizontalScanLines, CameraInfo::resolutionHeight, CameraInfo::resolutionWidth, rightPoint, and verticalLine. Referenced by execute().

Here is the call graph for this function:

void GuideDogRobotSpecialist::scanParallelToHorizon | ( |  | ) | `[private]`

| Definition at line 87 of file GuideDogRobotSpecialist.cpp. References Vector2< double >::abs(), PlayersPercept::addRedPlayer(), Geometry::calculatePointOnField(), Image::cameraInfo, DEBUG_IMAGE_SET_PIXEL_GRAY, DEBUG_IMAGE_SET_PIXEL_RED, SinglePlayerPercept::directionOnField, Geometry::PixeledLine::getNumberOfPixels(), Geometry::PixeledLine::getPixelX(), Geometry::PixeledLine::getPixelY(), idText, isRed(), leftPoint, LINE, numberOfHorizontalScanLines, SinglePlayerPercept::offsetOnField, OUTPUT, CameraInfo::resolutionHeight, CameraInfo::resolutionWidth, rightPoint, SinglePlayerPercept::validity, Vector2< double >::x, Vector2< V >::x, Vector2< double >::y, and Vector2< V >::y. Referenced by execute().

Here is the call graph for this function:

bool GuideDogRobotSpecialist::isRed | ( | int | x,
|  | int | y
| ) | `[inline, private]`

| Definition at line 156 of file GuideDogRobotSpecialist.cpp. References CORRECTED_COLOR_CLASS, and Image::image. Referenced by scanParallelToHorizon().

## Member Data Documentation

const Image& GuideDogRobotSpecialist::image`[private]`

| A reference to the image that is scanned for a goal. Definition at line 21 of file GuideDogRobotSpecialist.h.

const CameraMatrix& GuideDogRobotSpecialist::cameraMatrix`[private]`

| A reference to the camera matrix that describes position and rotation of the camera when the image was aquired. Definition at line 24 of file GuideDogRobotSpecialist.h.

const CameraMatrix& GuideDogRobotSpecialist::prevCameraMatrix`[private]`

| A reference to the previous camera matrix that describes position and rotation of the camera when the image was aquired. Definition at line 27 of file GuideDogRobotSpecialist.h.

const ColorTable& GuideDogRobotSpecialist::colorTable`[private]`

| A reference to the color table. Definition at line 30 of file GuideDogRobotSpecialist.h.

PlayersPercept& GuideDogRobotSpecialist::playersPercept`[private]`

| A reference to the singeplayer percept. Definition at line 33 of file GuideDogRobotSpecialist.h.

const ColorCorrector& GuideDogRobotSpecialist::colorCorrector`[private]`

| A reference to the color corrector. Definition at line 36 of file GuideDogRobotSpecialist.h.

Geometry::Line GuideDogRobotSpecialist::horizonLine`[private]`

| A representation of the horizon. Definition at line 39 of file GuideDogRobotSpecialist.h. Referenced by calculateScanLinesParallelToHorizon(), and execute().

Geometry::Line GuideDogRobotSpecialist::verticalLine`[private]`

| A representation of the horizon. Definition at line 39 of file GuideDogRobotSpecialist.h. Referenced by calculateScanLinesParallelToHorizon(), and execute().

int GuideDogRobotSpecialist::numberOfHorizontalScanLines`[private]`

| The number of horizontal scan lines. Definition at line 42 of file GuideDogRobotSpecialist.h. Referenced by calculateScanLinesParallelToHorizon(), and scanParallelToHorizon().

const int GuideDogRobotSpecialist::maxNumberOfHorizontalScanLines = 32`[static, private]`

| Definition at line 44 of file GuideDogRobotSpecialist.h. Referenced by calculateScanLinesParallelToHorizon().

Vector2<int> GuideDogRobotSpecialist::leftPoint[maxNumberOfHorizontalScanLines]`[private]`

| representation of the left points of the horizontal scan lines Definition at line 47 of file GuideDogRobotSpecialist.h. Referenced by calculateScanLinesParallelToHorizon(), and scanParallelToHorizon().

Vector2<int> GuideDogRobotSpecialist::rightPoint[maxNumberOfHorizontalScanLines]`[private]`

| representation of the right points of the horizontal scan lines Definition at line 50 of file GuideDogRobotSpecialist.h. Referenced by calculateScanLinesParallelToHorizon(), and scanParallelToHorizon().

The documentation for this class was generated from the following files:

- Modules/ImageProcessor/GT2005ImageProcessor/GuideDogRobotSpecialist.h
- Modules/ImageProcessor/GT2005ImageProcessor/GuideDogRobotSpecialist.cpp